package northwindsample;

import java.sql.*;

/**
 * @author Linglom
 */

public class SampleAccess2007 {

    private static Statement stmt = null;
    private static ResultSet rs = null;
    private static Connection con = null;

    public static void main(String[] args) {
        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

            /* Connection string to connect to Northwind database on MS Access 2007. */
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb, *.accdb)};" +
                    "DBQ=C:\\Database\\Northwind 2007.accdb";

            con = DriverManager.getConnection(url);
            System.out.println("Connected!");

            stmt = con.createStatement();

            Statement stmt = null;
            ResultSet rs = null;
            // SQL query command
            String SQL = "SELECT * FROM Customers";
            stmt = con.createStatement();
            rs = stmt.executeQuery(SQL);
            while (rs.next()) {
                System.out.println(rs.getString("Company") + " : "
                        + rs.getString("First Name")+ " : "
                        + rs.getString("Last Name"));
            }



            retrieveData("SELECT * FROM Customers");

            int rowsEffected = 0;

            // Example INSERT new record
            rowsEffected = updateData("INSERT INTO Customers (Company,[First Name]," +
                    "[Last Name]) VALUES ('MyCompany','Linglom','My Last Name')");
            System.out.println("/////////////////");
            System.out.print("Insert a new record : ");
            System.out.println(rowsEffected + " rows effected");
            retrieveData("SELECT * FROM Customers WHERE [First Name] = 'Linglom'");

            // Example UPDATE the record
            rowsEffected = updateData("UPDATE Customers SET [Last Name] = 'New Last Name'" +
                            "WHERE [First Name] = 'Linglom'");
            System.out.println("/////////////////");
            System.out.print("Update the record : ");
            System.out.println(rowsEffected + " rows effected");

            retrieveData("SELECT * FROM Customers WHERE [First Name] = 'Linglom'");

            // Example DELETE the record
            rowsEffected = updateData("DELETE FROM Customers WHERE [First Name] = 'Linglom'");
            System.out.println("/////////////////");
            System.out.print("Delete the record : ");
            System.out.println(rowsEffected + " rows effected");
            retrieveData("SELECT * FROM Customers WHERE [First Name] = 'Linglom'");

            con.close();
        } catch (SQLException e) {
            System.out.println("SQL Exception: "+ e.toString());
        } catch (ClassNotFoundException cE) {
            System.out.println("Class Not Found Exception: " + cE.toString());
        } catch (Exception ex) {
            System.out.println("Exception: " + ex.toString());
        }
    }

    /* Update data on the database
     * @param SQL an update commandstring (INSERT, DELETE, UPDATE)
     */
    public static int updateData(String SQL) throws Exception {
        return stmt.executeUpdate(SQL);
    }
    
    /* Show result on output window
     * @param SQL a retrive data command string (SELECT)
     */
    public static void retrieveData(String SQL) throws Exception {
        rs = stmt.executeQuery(SQL);
        
        while (rs.next()) {
            System.out.println(rs.getString("Company") + " : "
                        + rs.getString("First Name")+ " : "
                        + rs.getString("Last Name"));
            }
    }

}
